/*
Gemma the Tarsier-Cat 
Original Character by RalphJeremy65

Programming by SMS Alfredo
*/

freeslot("MT_GEMMAPLAT", "SPR_BLDR", "MT_GEMMAWALL", "SPR_EWAL", "MT_GEMMADIRT", "S_GEMMAPILLAR")

mobjinfo[MT_GEMMAPLAT] = {
	name = "rock platform",
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	deathsound = sfx_cdfm32,
	radius = 48*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = -1,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SLIDEME
}

mobjinfo[MT_GEMMAWALL] = {
	spawnstate = S_INVISIBLE,
	painstate = S_INVISIBLE,
	spawnhealth = 3,
	seesound = sfx_s3kccs,
	painsound = sfx_cdfm32,
	deathsound = sfx_s1b9,
	radius = 64*FRACUNIT,
	height = 132*FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_SCENERY|MF_SLIDEME
}

mobjinfo[MT_GEMMADIRT] = {
	spawnstate = S_MINUSDIRT1,
	painstate = S_GEMMAPILLAR,
	painsound = sfx_s3k9b,
	deathsound = sfx_cdfm32,
	radius = 16*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY|MF_MISSILE
}

states[S_GEMMAPILLAR] = {SPR_EWAL, G, TICRATE*2, A_Pain, 0,  0, S_NULL}

mobjinfo[MT_ROCKCRUMBLE2].mass = 0 //This is stupid
mobjinfo[MT_ROCKCRUMBLE2].damage = 1 //This is also stupid

//gemmastyle command
COM_AddCommand("gemmastyle", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0"
			CONS_Printf(player, "Style 0 for Gemma has been deprecated as of version 1.2. Defaulting to style 1.")
			player.gemmastyle = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "1" or arg == "default"
			player.gemmastyle = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "2"
			player.gemmastyle = 2
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(2)
				file:close()
			end
		else
			CONS_Printf(player, "gemmastyle - Changes how Gemma's jump ability controls.")
			CONS_Printf(player, "#1: Let go of Jump while riding the platform to hop off it.")
			CONS_Printf(player, "#2: Press Jump while riding the platform to hop off it.")
		end
	else
		CONS_Printf(player, "gemmastyle - Changes how Gemma's jump ability controls.")
		CONS_Printf(player, "#1: Let go of Jump while riding the platform to hop off it.")
		CONS_Printf(player, "#2: Press Jump while riding the platform to hop off it.")
	end
end, 0)

//Shatter the platform when it dies
addHook("MobjDeath", function(mobj)
	for i=0, 2
		local ghost = P_SpawnGhostMobj(mobj)
		if i == 1
			S_StartSound(ghost, mobj.info.deathsound)
		end
		ghost.fuse = TICRATE
		ghost.flags = $&~MF_NOGRAVITY
		ghost.flags2 = mobj.flags2&MF2_OBJECTFLIP
		ghost.eflags = mobj.eflags&MFE_VERTICALFLIP
		P_SetObjectMomZ(ghost, 4*FRACUNIT, false)
		if mobj.tracer and mobj.tracer.valid and mobj.tracer.player
			P_InstaThrust(ghost, (i*-ANGLE_90)+(mobj.tracer.player.cmd.angleturn<<16)+ANGLE_90, 4*mobj.scale)
		else
			P_InstaThrust(ghost, P_RandomKey(ANGLE_MAX), 4*mobj.scale)
		end
		ghost.sprite = SPR_BLDR
		ghost.frame = i+1
		i=$+1
	end
end, MT_GEMMAPLAT)

//Teleport the platform
addHook("MobjThinker", function(mobj)
	if not mobj.tracer return end
	if not (mobj.tracer.valid and mobj.tracer.skin == "gemma"
	and mobj.tracer.player and mobj.tracer.player.gemmasmash > 1)
	or not (mobj.flags&MF_NOGRAVITY)
		if mobj.flags&MF_NOGRAVITY
			mobj.z = $-P_MobjFlip(mobj.tracer)
			mobj.flags = $&~MF_NOGRAVITY&~MF_NOCLIPHEIGHT
			mobj.momx = mobj.tracer.momx
			mobj.momy = mobj.tracer.momy
			mobj.fuse = TICRATE*3
			if mobj.tracer.valid and (P_IsObjectOnGround(mobj.tracer)
			or (mobj.tracer.player and mobj.tracer.player.pflags&PF_JUMPED
			and not (mobj.tracer.player.pflags&PF_THOKKED)
			and not (mobj.tracer.player.pflags&PF_SPINNING)))
				P_KillMobj(mobj)
				return
			elseif mobj.tracer.valid and mobj.tracer.player
			and mobj.tracer.player.pflags&PF_SPINNING
				mobj.z = $-mobj.tracer.height*P_MobjFlip(mobj.tracer)/2
				mobj.momx = $*4/5
				mobj.momy = $*4/5
			end
		elseif P_IsObjectOnGround(mobj)
			P_KillMobj(mobj)
			return
		end
	elseif mobj.tracer.eflags&MFE_VERTICALFLIP
		mobj.eflags = $|MFE_VERTICALFLIP
		mobj.flags2 = $|MF2_OBJECTFLIP
		P_TeleportMove(mobj,mobj.tracer.x, mobj.tracer.y,
		mobj.tracer.z+mobj.tracer.height)
	else
		mobj.eflags = $&~MFE_VERTICALFLIP
		mobj.flags2 = $&~MF2_OBJECTFLIP
		P_TeleportMove(mobj,mobj.tracer.x, mobj.tracer.y,
		mobj.tracer.z-mobj.height)
	end
end, MT_GEMMAPLAT)

//Die
addHook("MobjFuse", function(mobj)
	P_KillMobj(mobj)
	return true
end, MT_GEMMAPLAT)

//Stupid
addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.gemmarock
		mobj.gemmarock = $+1
		if mobj.gemmarock > TICRATE*5
			P_SpawnGhostMobj(mobj)
			P_RemoveMobj(mobj)
		end
	end
end, MT_ROCKCRUMBLE2)

//Platform Collision
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and tmthing and tmthing.valid
		local splayer = thing.tracer and thing.tracer.valid and thing.tracer.player
		local tplayer = tmthing.player
		
		if thing.tracer == tmthing
			return false
			
		elseif tmthing.flags&MF_SHOOTABLE
		and (not splayer or not tplayer or CV_FindVar("friendlyfire").value
		or not (gametyperules & GTR_FRIENDLY or (G_GametypeHasTeams() and splayer.ctfteam == tplayer.ctfteam)))
		and (tplayer or tmthing.flags&MF_MONITOR or not (tmthing.flags&MF_SOLID))
		and (thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z)
			if splayer and thing.flags&MF_NOGRAVITY
				splayer.gemmasmash = 0
				splayer.mo.state = S_PLAY_SPRING
				splayer.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE&~PF_THOKKED
				if splayer.cmd.buttons&BT_JUMP
					splayer.pflags = $|PF_STARTJUMP
				end
				splayer.mo.momz = abs($)*P_MobjFlip(splayer.mo)
			end
			
			thing.flags = $|MF_MISSILE
			
			if splayer
				if CBW_Battle and CBW_Battle.GuardTrigger(tmthing, thing.tracer, thing.tracer, 1, 0)
					P_KillMobj(thing)
				elseif (not CBW_Battle or CBW_Battle.PlayerCorkDamage(tmthing, thing, thing.tracer) != false)
				and thing and thing.valid
					P_DamageMobj(tmthing, thing, splayer.mo)
					P_KillMobj(thing)
				end
			else
				P_DamageMobj(tmthing, thing, thing)
				P_KillMobj(thing)
			end
			
			if thing and thing.valid
				thing.flags = $&~MF_MISSILE
			end
			
		elseif not tplayer
			return false
			
		elseif P_IsObjectOnGround(tmthing) and not (tmthing.eflags&MFE_ONGROUND)
			if thing.tracer and thing.tracer.valid and thing.flags&MF_NOGRAVITY
				tmthing.momx = thing.tracer.momx
				tmthing.momy = thing.tracer.momy
			else
				tmthing.momx = thing.momx
				tmthing.momy = thing.momy
			end
			if tmthing.state != S_PLAY_WALK and tmthing.momx == 0 and tmthing.momy == 0
			and (tplayer.cmd.forwardmove or tplayer.cmd.sidemove)
				tmthing.state = S_PLAY_WALK
			end
			tplayer.powers[pw_noautobrake] = max($,2)
		end
	end
end, MT_GEMMAPLAT)

//Platform Protection
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not (target and target.valid and target.player and target.skin == "gemma"
	and target.player.gemmasmash and target.player.gemmasmash >= 2 and not (damagetype&DMG_DEATHMASK)) then return end
	local inflvald = (inflictor and inflictor.valid)
	if (damagetype != DMG_WATER and not inflvald)
	or (inflvald and inflictor.type == MT_SPIKE
	and (target.eflags & MFE_VERTICALFLIP) == (inflictor.eflags & MFE_VERTICALFLIP))
	or (inflvald and not P_IsObjectOnGround(target)
	and inflictor.type != MT_WALLSPIKE)
	
	if inflvald
		local bottomheight = target.z
		local topheight = target.z + target.height

		if (target.eflags & MFE_VERTICALFLIP)
			local swap = bottomheight
			bottomheight = topheight
			topheight = swap
		end

		if not ((P_MobjFlip(target)*(bottomheight - (inflictor.z + inflictor.height/2)) > 0)
		and (P_MobjFlip(target)*(target.momz - inflictor.momz) < 0)) then return end
	
		target.z = $+(inflictor.height/2)
	else
		target.z = $+P_MobjFlip(target)
	end
	
	local spoark = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_THUNDERCOIN_SPARK)
	spoark.fuse = TICRATE/3
	spoark.scale = target.scale*3/2
	target.momz = max(abs(target.momz), 10*target.scale)
	target.player.gemmasmash = 0
	target.state = S_PLAY_SPRING
	target.player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_THOKKED
	if target.player.cmd.buttons&BT_JUMP
		target.player.pflags = $|PF_STARTJUMP
	end
	S_StartSound(target, sfx_cdfm65)
	
	return false end
end, MT_PLAYER)

//Start the ability
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "gemma" and player.panim != PA_PAIN
	and not player.gotflag and not player.gotcrystal
		if (player.gemmasmash and player.gemmasmash > 1)
		or player.gemmaspindash
			player.pflags = $&~PF_JUMPED
			P_DoJump(player)
			player.gemmasmash = 0
			if not (player.pflags&PF_SPINNING)
				player.pflags = $|PF_THOKKED&~PF_NOJUMPDAMAGE
			end
		elseif (not (player.pflags&PF_THOKKED) or player.charflags&SF_MULTIABILITY
		or player.powers[pw_super]) and not P_IsObjectInGoop(player.mo)
			player.gemmasmash = 1
			player.pflags = $|PF_THOKKED|PF_JUMPED&~PF_STARTJUMP&~PF_NOJUMPDAMAGE&~PF_SPINNING
			local dumbgravity = P_GetMobjGravity(player.mo)
			if player.mo.eflags&MFE_UNDERWATER and not P_IsObjectInGoop(player.mo)
			dumbgravity = player.mo.scale*2/-5*P_MobjFlip(player.mo) end
			if player.mo.eflags&MFE_UNDERWATER
				player.mo.momz = $+(max(min(dumbgravity,player.mo.scale/2),player.mo.scale/-2)*-32)
			else
				player.mo.momz = $+(max(min(dumbgravity,player.mo.scale/2),player.mo.scale/-2)*-48)
			end
			S_StartSound(player.mo, sfx_s3kabf)
		end
	end
end)

//Rock spindash
addHook("SpinSpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "gemma" and player.panim != PA_PAIN
	and player.gemmasmash
		if player.gemmasmash > 1
		and not (player.pflags&PF_USEDOWN) and not player.gemmaspindash
			player.gemmadashspeed = 15*FRACUNIT
			player.mo.state = S_PLAY_SPINDASH
			player.gemmaspindash = 1
			S_StartSound(player.mo, sfx_spndsh)
		end
		return true
	end
end)

//Bouncy
addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.skin == "gemma"
	and inflictor.player
		if inflictor.player.gemmasmash
			if inflictor.player.gemmasmash > 1
				inflictor.player.gemmasmash = 0
				inflictor.state = S_PLAY_SPRING
				inflictor.player.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE
				if inflictor.player.cmd.buttons&BT_JUMP
					inflictor.player.pflags = $|PF_STARTJUMP
				end
			else
				inflictor.momz = $*2
			end
		end
		inflictor.player.pflags = $&~PF_THOKKED
	end
end)

//Bouncy!
addHook("MobjDeath", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.skin == "gemma"
	and inflictor.player and target and target.valid and target.flags&MF_MONITOR
		if inflictor.player.gemmasmash
			if inflictor.player.gemmasmash > 1
				inflictor.player.gemmasmash = 0
				inflictor.state = S_PLAY_SPRING
				inflictor.player.pflags = $|PF_JUMPED|PF_STARTJUMP|PF_NOJUMPDAMAGE
				if inflictor.player.cmd.buttons&BT_JUMP
					inflictor.player.pflags = $|PF_STARTJUMP
				end
			else
				inflictor.momz = $*2
			end
		end
		inflictor.player.pflags = $&~PF_THOKKED
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "gemma"
	and player.gemmaspindash
		return true
	end
end)

//Reset Gemma's variables
local resetgemma = function(player)
	player.gemmamomz = 0
	if player.mo and player.mo.valid
	and (player.gemmasmash == 1 or player.gemmasquish)
		player.mo.spritexscale = FRACUNIT
		player.mo.spriteyscale = FRACUNIT
	end
	player.gemmasmash = 0
	player.gemmasquish = 0
	player.gemmaspindash = 0
end
addHook("PlayerSpawn", function(player)
	resetgemma(player)
	//I/O maybe
	if io and player.gemmastyle == nil and player == consoleplayer
		local file = io.openlocal("client/Gemma.dat")
		if file
			local num = file:read("*n")
			if num != nil and num >= 0 and num <= 2
				COM_BufInsertText(consoleplayer, "gemmastyle "..num)
			end
			file:close()
		end
	end
end)

//Main Thinker	
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "gemma"
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.gotflag
		or player.gotcrystal
		or player.iseggrobo
		or player.isjettysyn
		or player.guard
		or player.airdodge
		or player.actionstate
		or player.powers[pw_nocontrol]
		or player.exiting
			resetgemma(player)
			if player.charflags&SF_STOMPDAMAGE
				player.charflags = $&~SF_STOMPDAMAGE
			end
		return end
		
		//Do the ability
		if player.gemmasmash
			if player.gemmasmash == 1
				if P_IsObjectInGoop(player.mo)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.gemmasmash = 0
				elseif player.mo.eflags&MFE_SPRUNG
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					S_StartSound(player.mo, sfx_sprong)
					if (player.mo.eflags & MFE_UNDERWATER)
						local ex = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_UWEXPLODE)
						if ex and ex.valid ex.scale = $/2 end
					else
						P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale*P_MobjFlip(player.mo), MT_SPINDUST)
					end
					player.gemmasmash = 0
				elseif P_IsObjectOnGround(player.mo)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.gemmasquish = 4
					player.mo.state = S_PLAY_GLIDE_LANDING
					if player.powers[pw_super]
						P_Earthquake(player.mo, player.mo, RING_DIST)
					end
					if player == displayplayer and not splitscreen
						P_StartQuake(32*FRACUNIT, 2+min(player.powers[pw_super],1))
					end
					
					if player.cmd.buttons&BT_JUMP
						player.mo.momz = player.gemmamomz/-2
						if player.mo.momz*P_MobjFlip(player.mo) < 8*player.mo.scale
							P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
						end
						player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
						if player.gemmastyle == 2
							player.gemmasmash = 2
						else
							player.gemmasmash = 5
						end
						player.pflags = $|PF_JUMPSTASIS
						player.charflags = $|SF_STOMPDAMAGE
						local rock = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_GEMMAPLAT)
						rock.blockable = 2
						rock.block_stun = 3
						rock.block_sound = sfx_s3k49
						rock.block_hthrust = 6
						rock.block_vthrust = 2
						
						rock.sprite = SPR_BLDR
						rock.frame = 0
						rock.tracer = player.mo
						rock.target = player.mo
						rock.flags2 = $|MF2_LINKDRAW
						
						local ghost = P_SpawnGhostMobj(rock)
						ghost.frame = 4
						if RF_FLOORSPRITE
							ghost.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_SHADOWDRAW|RF_OBJECTSLOPESPLAT
							P_CreateFloorSpriteSlope(ghost)
							ghost.flags = $&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
							ghost.flags2 = player.mo.flags2&MF2_OBJECTFLIP
							ghost.eflags = player.mo.eflags&MFE_VERTICALFLIP
							ghost.height = ghost.scale
							ghost.z = $ - rock.height*P_MobjFlip(ghost)
							ghost.fuse = TICRATE*5
						else
							ghost.fuse = TICRATE
						end
						ghost.angle = player.cmd.angleturn<<16
						
						S_StartSound(player.mo, sfx_s3k82)
						S_StartSoundAtVolume(player.mo, sfx_s3k7a, 192)
						S_StartSoundAtVolume(player.mo, sfx_s1b9, 192)
					else
						S_StartSound(player.mo, sfx_s3k4c)
						S_StartSoundAtVolume(player.mo, sfx_s3k59, 192)
						player.gemmasmash = 0
					end
					
					local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
					thok.color = SKINCOLOR_BEIGE
					thok.destscale = thok.scale*16
					thok.scalespeed = $*2
					thok.tics = $*3/2
					thok.fuse = thok.tics
					
					local i = 0	while i < 8
						local ns = 16 << FRACBITS
						local mo = P_SpawnMobj(player.mo.x, player.mo.y,
						player.mo.z+(player.mo.height/2), MT_ROCKCRUMBLE2)
						if mo and mo.valid
							mo.angle = (i*(ANGLE_180/4))
							if player.powers[pw_super]
								mo.momx = FixedMul(sin(mo.angle),ns)*2
								mo.momy = FixedMul(cos(mo.angle),ns)*2
							else
								mo.momx = FixedMul(sin(mo.angle),ns)/2
								mo.momy = FixedMul(cos(mo.angle),ns)/2
							end
							mo.gemmarock = 1
							mo.hit_sound = sfx_hit04
							mo.blockable = 1
							mo.block_stun = 3
							mo.block_sound = sfx_s3k49
							mo.block_hthrust = 6
							mo.block_vthrust = 2
							mo.spawnfire = true
							mo.target = player.mo
							mo.flags = $&~MF_NOCLIP&~MF_NOCLIPTHING|MF_MISSILE|MF_NOCLIPHEIGHT
							mo.shadowscale = FRACUNIT/3
							mo.radius = $*4
						end
						i = $+1
					end
					
					S_StopSoundByID(player.mo, sfx_s3kabf)
				else
					player.pflags = $|PF_JUMPSTASIS
					player.mo.state = S_PLAY_ROLL
					player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
					player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
					if player.cmd.buttons&BT_JUMP
						local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
						thok.color = player.mo.color
						thok.destscale = 1
						thok.scalespeed = thok.scale/6
						thok.tics = $*3/2
						thok.fuse = thok.tics
						thok.spritexscale = player.mo.spritexscale
						//thok.spriteyscale = player.mo.spriteyscale
						local thok = P_SpawnMobjFromMobj(player.mo,
						FixedDiv(player.mo.momx/-2,player.mo.scale),
						FixedDiv(player.mo.momy/-2,player.mo.scale),
						FixedDiv(player.mo.momz/-2,player.mo.scale),MT_THOK)
						thok.color = player.mo.color
						thok.destscale = 1
						thok.scalespeed = thok.scale/6
						P_SetScale(thok, thok.scale-thok.scalespeed/2)
						thok.tics = $*3/2
						thok.fuse = thok.tics
						thok.spritexscale = player.mo.spritexscale
						//thok.spriteyscale = player.mo.spriteyscale
					else
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.color = SKINCOLOR_BEIGE
						ghost.colorized = true
						ghost.fuse = 4
						ghost.spritexscale = player.mo.spritexscale
						ghost.spriteyscale = player.mo.spriteyscale
					end
					if player.mo.momz*P_MobjFlip(player.mo) > -32*player.mo.scale
						player.mo.momz = $+(P_GetMobjGravity(player.mo)*8)
					elseif player.mo.momz*P_MobjFlip(player.mo) > -48*player.mo.scale
						player.mo.momz = $+(P_GetMobjGravity(player.mo)*2)
					end
					local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
					if sectorthing and sectorthing.valid then
						for fof in sectorthing.ffloors()
							if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
							and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
								EV_CrumbleChain(player.sectorthing, fof)
							end
						end
					end
				end
			elseif not (player.cmd.buttons&BT_JUMP) and player.gemmasmash == 5
				player.pflags = $&~PF_JUMPED
				P_DoJump(player)
				player.gemmasmash = 0
				player.pflags = $|PF_THOKKED&~PF_STARTJUMP&~PF_NOJUMPDAMAGE
			elseif P_IsObjectOnGround(player.mo)
			or player.pflags&PF_STARTJUMP
				player.gemmasmash = 0
			else
				player.pflags = $|PF_JUMPED
				if not player.gemmaspindash
					player.mo.state = S_PLAY_GLIDE_LANDING
				end
				if player.gemmasmash >= 3 and player.gemmasmash < 5
					if player.cmd.buttons&BT_JUMP
						player.gemmasmash = $+1
					else
						player.gemmasmash = 2
					end
				end
			end
			player.gemmamomz = player.mo.momz
		elseif player.charflags&SF_STOMPDAMAGE
			player.charflags = $&~SF_STOMPDAMAGE
		end
		
		if player.gemmasquish
			player.gemmasquish = $-1
			player.mo.spritexscale = FRACUNIT+(player.gemmasquish)*FRACUNIT/6
			player.mo.spriteyscale = FRACUNIT-(player.gemmasquish)*FRACUNIT/6
		end
		
		if player.gemmaspindash
			if player.gemmaspindash == -1
				player.gemmaspindash = 0
				player.pflags = $&~PF_JUMPED
				player.gemmasmash = 0
			elseif player.cmd.buttons & BT_SPIN
			and player.gemmasmash and player.gemmasmash > 1
				player.mo.state = S_PLAY_SPINDASH
				
				local chargecalculation = (6*(player.gemmadashspeed  - (player.mindash)))/((player.maxdash) - (player.mindash))
				player.gemmadashspeed = min(max($+FRACUNIT, player.mindash), player.maxdash)
				local soundcalculation = (6*(player.gemmadashspeed  - (player.mindash)))/((player.maxdash) - (player.mindash))
				if not player.spectator and soundcalculation != chargecalculation
					S_StartSound(player.mo, sfx_spndsh)
				end
			
				local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
					local particle
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SMALLBUBBLE)
					else
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
							particle.state = S_SPINDUST_FIRE1
						end
					end
				
					particle.target = player.mo
					particle.destscale = (2*player.mo.scale)/3
					P_SetScale(particle, particle.destscale)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						particle.z = player.mo.z + player.mo.height - particle.height
					end
					local prandom = {}
					prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
					prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
					prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
					P_SetObjectMomZ(particle, player.gemmadashspeed /50 + prandom[0], false)
					P_InstaThrust(particle,
							player.mo.angle + (prandom[1]*ANG1),
							-FixedMul(player.gemmadashspeed /12 + FRACUNIT + prandom[2], player.mo.scale))
					particle.momx = $+player.mo.momx
					particle.momy = $+player.mo.momy
					particle.momz = $+player.mo.momz
					P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				
					i = $+1
				end
			elseif not (player.cmd.buttons&BT_USE)
			or P_IsObjectOnGround(player.mo)
				P_InstaThrust(player.mo, player.mo.angle, FixedMul(player.gemmadashspeed , player.mo.scale))
				S_StartSound(player.mo, sfx_s23c)
				player.pflags = $|PF_SPINNING&~PF_THOKKED
				player.gemmaspindash = -1
				if player.mo.momz*P_MobjFlip(player.mo) < 0
					player.mo.momz = 0
				end
				player.mo.state = S_PLAY_ROLL
			else
				player.gemmaspindash = 0
			end
		end
	end
end)

//
//Battle Mod Support
//

local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	local B = CBW_Battle

	
	local function GarbagePriority7(player)
		if player.gemmasmash == 1 and not P_IsObjectOnGround(player.mo)
			B.SetPriority(player,1,1,"fang_tailbounce",2,1,"ground pound")
			
		elseif player.gemmasmash > 1 and not P_IsObjectOnGround(player.mo)
			B.SetPriority(player,0,0,"fang_tailbounce",2,99,"rock platform")
			
		elseif player.actionstate == 3 and not P_IsObjectOnGround(player.mo)
			B.SetPriority(player,1,1,"fang_tailbounce",3,3,"charged ground pound")
			
		elseif player.gemmaspindash
			B.SetPriority(player,1,1,"fang_tailbounce",2,99,"platform spindash")
		end
	end
	
	//Ability
	local function GemmaBattle(mo,doaction)
		local player = mo.player
		if player.gemmarockwall
			if player.gemmarockwall.valid and player.gemmarockwall.health
			and player.gemmarockwall.type == MT_GEMMAWALL
				player.gemmarockwall.target = mo
				player.action2text = "\x80".."Wall HP \x83"..player.gemmarockwall.health.."/3"
				
				if not P_IsObjectOnGround(mo) or player.actionstate
					player.actiontext = "Rock Wave"
					player.actionrings = 10
				else
					player.actiontext = "Destroy wall"
					player.actionrings = 0
				end
			else
				player.gemmarockwall = nil
				S_StartSound(mo, sfx_jshard, player)
				B.ApplyCooldown(player,TICRATE*3)
			end
		elseif P_IsObjectOnGround(mo) and not player.actionstate
			player.actiontext = "Earth Wall"
			player.actionrings = 10
		else
			player.actiontext = "Rock Wave"
			player.actionrings = 10
		end
		player.action2rings = 0
		
		if not(B.CanDoAction(player))
			player.actionstate = 0 --Default action state
		return end
		
		if player.actionstate
			player.actiontime = $ + 1
			
			mo.momx = $*7/8
			mo.momy = $*7/8
			
			if player.actionstate == 1
				mo.momz = $/2
				
				if player.actiontime == TICRATE/3
					player.actionstate = 2
					player.actiontime = 0
					
					P_SetObjectMomZ(mo, 16*FRACUNIT, false)
					S_StartSound(mo, sfx_kc38)
					S_StartSound(mo, sfx_3db16)
					S_StopSoundByID(mo, sfx_s3kcbs)
				end
			elseif player.actionstate == 2
				if player.actiontime == TICRATE/3
					player.actionstate = 3
					player.actiontime = 0
					
					S_StartSound(mo, sfx_s3k83)
					S_StopSoundByID(mo, sfx_kc38)
					S_StopSoundByID(mo, sfx_3db16)
				end
			elseif player.actionstate == 3
				if P_IsObjectOnGround(mo)
					player.pflags = $|PF_FULLSTASIS
					player.actionstate = 4
					player.actiontime = 0
					
					S_StartSound(mo, sfx_kc40)
					S_StartSound(mo, sfx_s3kccs)
					S_StopSoundByID(mo, sfx_s3k83)
					
					if player == displayplayer and not splitscreen
						P_StartQuake(8*FRACUNIT, 7)
					end
					
					for i = 0, 7
						local dirt = P_SpawnMobjFromMobj(mo, 0,0,0, MT_GEMMADIRT)
						P_Thrust(dirt, player.drawangle - ANGLE_45 + (ANGLE_11hh*i), 32*mo.scale)
						dirt.target = mo
						dirt.hit_sound = sfx_hit01
						dirt.blockable = 2
						dirt.block_stun = 4
						dirt.block_sound = sfx_s3k49
						dirt.block_hthrust = 1
						dirt.block_vthrust = 12
						dirt.flags = $|MF_MISSILE
						
						if not (gametyperules & GTR_FRIENDLY)
							dirt.color = player.skincolor
							dirt.colorized = true
						end
					end
				else
					P_SetObjectMomZ(mo, -64*FRACUNIT, false)
					mo.spritexscale = FRACUNIT*2/3
					mo.spriteyscale = FRACUNIT*3/2
				end
			elseif player.actionstate == 4
				mo.state = S_PLAY_GLIDE_LANDING
				player.pflags = $|PF_FULLSTASIS
				
				if player.actiontime == TICRATE
					mo.state = S_PLAY_STND
					
					B.ApplyCooldown(player,TICRATE*3)
					player.actionstate = 0
					player.actiontime = 0
				end
			end
			
			if player.actionstate and player.actionstate < 4
				if not P_IsObjectOnGround(mo)
					mo.z = $ + mo.scale*P_MobjFlip(mo)
				end
				player.pflags = $|P_GetJumpFlags(player)
				mo.state = S_PLAY_JUMP
				player.gemmasquish = 4
				
				if player.actionstate > 1 or not (player.actiontime%3)
					local ghost = P_SpawnGhostMobj(mo)
					ghost.spritexscale = mo.spritexscale
					ghost.spriteyscale = mo.spriteyscale
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.scalespeed = ghost.scale/16
					ghost.destscale = $*16
				end
			end
			
		elseif player.actionstate == 0
		and doaction == 1
			if not P_IsObjectOnGround(mo)
				player.actionstate = 1
				player.actiontime = 0
				B.PayRings(player)
				
				S_StartSound(mo, sfx_s3kcbs)
				S_StartSound(mo, sfx_cdfm23)
				S_StartSound(mo, sfx_s3k9c)
				for d = 0, 16
					P_SpawnParaloop(mo.x + mo.momx*4, mo.y + mo.momy*4, mo.z + mo.height/2,
					64*mo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, false)
				end
			elseif player.gemmarockwall and player.gemmarockwall.valid
			and player.gemmarockwall.health and player.gemmarockwall.type == MT_GEMMAWALL
				P_KillMobj(player.gemmarockwall)
			else
				local thokmobj = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
				local oldheight = thokmobj.height
				thokmobj.radius = FixedMul(mobjinfo[MT_GEMMAWALL].radius*2, mo.scale)
				thokmobj.height = FixedMul(mobjinfo[MT_GEMMAWALL].height, mo.scale)
				thokmobj.flags2 = $|MF2_DONTDRAW
				
				if P_MobjFlip(mo) == -1
					thokmobj.z = $-(thokmobj.height-oldheight)
				end
				
				thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				if P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
				mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
				and thokmobj.z - thokmobj.scale*8 <= mo.z + mo.height
				and thokmobj.z + thokmobj.height + thokmobj.scale*8 >= mo.z
					local foundmobj = 0
					searchBlockmap("objects", function(refmobj, mobj)
						if not (mobj and mobj.valid and mobj.health
						and mobj != mo and mobj.flags&(MF_SHOOTABLE|MF_SOLID))
						or R_PointToDist2(refmobj.x, refmobj.y, mobj.x, mobj.y) > refmobj.radius + mobj.radius
						or refmobj.z - refmobj.scale > mobj.z + mobj.height
						or refmobj.z + refmobj.height + refmobj.scale < mobj.z
							return
						end
						
						foundmobj = mobj
					end, thokmobj)
					
					if foundmobj or abs((thokmobj.z + thokmobj.height/2) - (mo.z + mo.height/2)) > mo.height
						S_StartSound(mo, sfx_s3k8c, player)
					else
						player.gemmarockwall = P_SpawnMobjFromMobj(thokmobj, 0, 0, 0, MT_GEMMAWALL)
						player.gemmarockwall.flags = $|MF_NOCLIPTHING
						player.gemmarockwall.angle = mo.angle
						player.gemmarockwall.target = mo
						player.gemmarockwall.gemmaid = -1
						
						if not (gametyperules & GTR_FRIENDLY)
							player.gemmarockwall.color = player.skincolor
							player.gemmarockwall.colorized = true
						end
						
						B.PayRings(player)
						B.ApplyCooldown(player,TICRATE)
					end
				else
					thokmobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
					P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
					mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
					S_StartSound(mo, sfx_s3k8c, player)
				end
			end
		end
	end
	
	//Stats
	B.SkinVars["gemma"] = {
		special = GemmaBattle,
		func_priority_ext = GarbagePriority7,
	}
end)

//Wall thinker
addHook("MobjThinker", function(mobj)
	if not mobj.gemmaid then return end
	
	if mobj.gemmaid > 0
		if not (mobj.tracer and mobj.tracer.valid and mobj.tracer.health)
		then P_RemoveMobj(mobj) return end
		mobj.scale = mobj.tracer.scale
		mobj.color = mobj.tracer.color
		mobj.colorized = mobj.tracer.colorized
		mobj.frame = 3-mobj.tracer.health
		mobj.blendmode = mobj.tracer.blendmode
		mobj.flags2 = mobj.tracer.flags2
		mobj.eflags = mobj.tracer.eflags
		mobj.target = mobj.tracer.target
		
		if mobj.gemmaid >= 5
			local zoffset = FixedMul(mobj.tracer.spriteyscale, mobj.tracer.height)*P_MobjFlip(mobj)
			local negative = mobj.gemmaid > 5 and -1 or 1
			mobj.angle = mobj.tracer.angle
			
			if mobj.gemmaid >= 7
				zoffset = 0
				mobj.state = S_INVISIBLE
			else
				if P_MobjFlip(mobj) == -1
					zoffset = $ + mobj.tracer.height
				end
				mobj.frame = $+3
			end
			
			P_TeleportMove(mobj,
			mobj.tracer.x + P_ReturnThrustX(nil, mobj.angle - ANGLE_90, mobj.radius*negative),
			mobj.tracer.y + P_ReturnThrustY(nil, mobj.angle - ANGLE_90, mobj.radius*negative),
			mobj.tracer.z + zoffset)
		else
			local dist = mobj.radius
			mobj.angle = mobj.tracer.angle + ANGLE_90 * (mobj.gemmaid-1)
			mobj.spriteyscale = mobj.tracer.spriteyscale
			
			if not (mobj.gemmaid % 2)
				dist = $/2
			else
				dist = $*2
			end
			
			P_TeleportMove(mobj,
			mobj.tracer.x + P_ReturnThrustX(nil, mobj.angle - ANGLE_90, dist),
			mobj.tracer.y + P_ReturnThrustY(nil, mobj.angle - ANGLE_90, dist),
			mobj.tracer.z)
		end
	elseif not mobj.cusval
		for i=1,8
			local wall = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_GEMMAWALL)
			wall.target = mobj.target
			wall.tracer = mobj
			wall.sprite = SPR_EWAL
			wall.gemmaid = i
			wall.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
			
			if wall.gemmaid >= 7
				wall.state = S_INVISIBLE
				wall.angle = mobj.angle
			elseif wall.gemmaid >= 5
				wall.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD
				wall.frame = $+3
				wall.height = wall.scale
				wall.angle = mobj.angle
			else
				if not (i % 2)
					wall.spritexscale = FRACUNIT*2
					wall.radius = $*2
				end
			
				wall.renderflags = $|RF_PAPERSPRITE
				wall.flags = $|MF_PAPERCOLLISION
				wall.angle = mobj.angle + ANGLE_90 * (i-1)
			end
		end
		
		for i = -4, 4
			for d = -4, 4
				local dust = P_SpawnMobjFromMobj(mobj,
				P_ReturnThrustX(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				P_ReturnThrustY(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				0, MT_TNTDUST)
			end
		end
		
		S_StartSound(mobj, mobj.info.seesound)
		mobj.spriteyscale = FRACUNIT/16
		mobj.cusval = 1
	elseif mobj.spriteyscale < FRACUNIT
		mobj.spriteyscale = min($ + FRACUNIT/16, FRACUNIT)
	elseif mobj.fuse % 2
		mobj.flags2 = $|MF2_SHADOW
	else
		mobj.flags2 = $&~MF2_SHADOW
	end
end, MT_GEMMAWALL)

//No colliding the wall with itself
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and tmthing and tmthing.valid
	and tmthing.type == MT_GEMMAWALL
		return false
	end
end, MT_GEMMAWALL)

//Are we able to damage the wall? Should we transfer the damage to the object source?
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not target.fuse and target.target != inflictor
	and target.target != source and not (G_GametypeHasTeams() and target.target
	and target.target.valid and target.target.player and source and source.valid
	and source.player and target.target.player.ctfteam == source.player.ctfteam)
		if target.gemmaid > 0
			if target.tracer and target.tracer.valid
			and not target.tracer.fuse
				if inflictor and inflictor.valid
					S_StartSound(inflictor, target.info.painsound)
				end
				P_DamageMobj(target.tracer, inflictor, source, damage, damagetype)
			end
			return false
		end
		target.fuse = TICRATE
	else
		return false
	end
end, MT_GEMMAWALL)

//Wall collision for damage
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and not (thing.renderflags&RF_FLOORSPRITE)
	and tmthing and tmthing.valid and tmthing.player
	and tmthing.player.battle_atk and not thing.fuse
	and thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z
	and thing.target != tmthing and not (G_GametypeHasTeams() and thing.target
	and thing.target.valid and thing.target.player
	and tmthing.player and thing.target.player.ctfteam == tmthing.player.ctfteam)
		if thing.gemmaid > 0
			if thing.tracer and thing.tracer.valid and not thing.tracer.fuse
				P_DamageMobj(thing.tracer, tmthing, tmthing, 1, 0)
				if tmthing and tmthing.valid
					local angle = thing.flags & MF_PAPERCOLLISION and thing.angle - ANGLE_90 or R_PointToAngle2(thing.x, thing.y, tmthing.x, tmthing.y)
					S_StartSound(tmthing, thing.info.painsound)
					P_InstaThrust(tmthing, angle,
					max(tmthing.player.speed, 24*thing.scale))
					tmthing.momz = -$
					tmthing.flags = $|MF_NOCLIPTHING
					P_TryMove(tmthing, tmthing.x + tmthing.momx, tmthing.y + tmthing.momy, true)
					tmthing.z = $ + tmthing.momz
					tmthing.flags = $&~MF_NOCLIPTHING
				end
			end
			return false
		else
			P_DamageMobj(thing, tmthing, tmthing, 1, 0)
		end
	end
end, MT_GEMMAWALL)

//Dumb Debris
addHook("MobjFuse", function(mobj) return true end, MT_GEMMAWALL)
addHook("MobjDeath", function(mobj)
	S_StartSound(mobj, mobj.info.deathsound)
	mobj.health = 0
	mobj.tics = TICRATE*2
	mobj.flags = $|MF_NOCLIP
	for z = 0, 4
		for i = -4, 4
			for d = -4, 4
				local rock = P_SpawnMobjFromMobj(mobj,
				P_ReturnThrustX(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				P_ReturnThrustY(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				mobj.info.height - (mobj.info.height/4*z), MT_ROCKCRUMBLE1)
				if rock and rock.valid
					rock.color = mobj.color
					rock.colorized = mobj.colorized
					rock.flags2 = $&~MF2_OBJECTFLIP
					rock.eflags = $&~MFE_VERTICALFLIP
					rock.fuse = TICRATE*5
				end
			end
		end
	end
	return true
end, MT_GEMMAWALL)

//Dirt stuff
addHook("MobjThinker", function(mobj)
	if not P_IsObjectOnGround(mobj)
		mobj.momz = $ + P_GetMobjGravity(mobj)*7
	elseif leveltime%2 and mobj.state != mobj.info.painstate
		local ngangle = FixedAngle(((leveltime * 42) % 360) << FRACBITS)
		local xofs = sin(ngangle) * (mobj.radius>>FRACBITS) + FixedDiv(mobj.momx*2, mobj.scale)
		local yofs = cos(ngangle) * (mobj.radius>>FRACBITS) + FixedDiv(mobj.momy*2, mobj.scale)

		local spark = P_SpawnMobjFromMobj(mobj, xofs, yofs, 0, MT_BOXSPARKLE)
		spark.fuse = 12
		spark.momz = mobj.height/spark.fuse*P_MobjFlip(mobj)
		spark.momx = mobj.momx/8
		spark.momy = mobj.momy/8
	end
	if mobj.state == mobj.info.painstate
		mobj.spriteyscale = min(abs(TICRATE*2 - mobj.tics) * FRACUNIT/(TICRATE/8), FRACUNIT)
		if mobj.tics == 1
			for i=0, 2
				local ghost = P_SpawnGhostMobj(mobj)
				if i == 1
					S_StartSound(ghost, mobj.info.deathsound)
				end
				ghost.fuse = TICRATE
				ghost.flags = $&~MF_NOGRAVITY
				ghost.flags2 = mobj.flags2&MF2_OBJECTFLIP
				ghost.eflags = mobj.eflags&MFE_VERTICALFLIP
				P_SetObjectMomZ(ghost, 6*FRACUNIT, false)
				if mobj.target and mobj.target.valid and mobj.target.player
					P_InstaThrust(ghost, (i*-ANGLE_90)+(mobj.target.player.cmd.angleturn<<16)+ANGLE_90, 4*mobj.scale)
				else
					P_InstaThrust(ghost, P_RandomKey(ANGLE_MAX), 4*mobj.scale)
				end
				ghost.sprite = SPR_EWAL
				ghost.frame = H+i
			end
		end
	else
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.destscale = ghost.scale*4
		
		if mobj.state >= S_MINUSDIRT1 and mobj.state <= S_MINUSDIRT7
			mobj.tics = min($, 4)
		end
	end
	if mobj.target and mobj.target.valid
		mobj.flags = $|MF_MISSILE&~MF_NOCLIPTHING&~MF_NOGRAVITY
		mobj.health = mobj.info.spawnhealth
	end
end, MT_GEMMADIRT)

addHook("ShouldDamage", function(target, mobj)
	if mobj and mobj.valid and mobj.type == MT_GEMMADIRT
	and (not P_IsObjectOnGround(mobj) or not (target and target.valid and P_IsObjectOnGround(target)))
		return false
	end
end)

local dirtrise = function(target, mobj)
	if mobj and mobj.valid and mobj.type == MT_GEMMADIRT
	and not mobj.threshold and mobj.state != mobj.info.painstate
		mobj.state = mobj.info.painstate
		mobj.spriteyscale = min(abs(TICRATE*2 - mobj.tics) * mobj.scale/(TICRATE/8), mobj.scale)
		mobj.momx = 0
		mobj.momy = 0
		mobj.threshold = 1
		
		if target and target.valid
			mobj.flags = $&~MF_MISSILE
			P_TeleportMove(mobj, target.x, target.y, mobj.z)
			mobj.flags = $|MF_MISSILE
		end
	end
end
addHook("MobjDamage", dirtrise)
addHook("MobjDeath", dirtrise)

// Stand Animation Fix
addHook("PlayerSpawn", function(p)
    if (p.mo.skin == "gemma")
        p.mo.state = $
    end
end)